Redmine - Feature #16045

Add "Author / Previous assignee™ group to assignee dropdown in issue form
2014-02-06 18:45 - Gurvan Le Dromaguet

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 6.0.0

Resolution:

Description

Intention : assign ticket back to previous assignee easily, without scrolling down the list until | found it.
attached proposed implementation as svn patch. It needs to run "db:migrate”

Missing in the implementation:

- previous assignee in contextual menu

- maybe reusing changes done in r12419

Works good and very popular in my firm.

Related issues:

Related to Redmine - Feature #19501: Assign issue to <<author>> Closed
Related to Redmine - Feature #14602: Assignee list should be (optionally) ord... New
Related to Redmine - Feature #23072: Speed-Up the setting of "assigned to" by... New
Related to Redmine - Feature #35282: Assign to former/previous assignee short... Closed
Has duplicate Redmine - Feature #24319: Last assigned to option in the Assign... Closed

Associated revisions

Revision 23059 - 2024-09-15 08:31 - Go MAEDA

Add "Author / Previous assignee" group to assignee dropdown in issue form (#16045).

Patch by Luka Ludicke (user:dkd-luedicke), Mizuki ISHIKAWA (user:ishikawa999), and Go MAEDA (user:maeda).

Revision 23060 - 2024-09-15 08:33 - Go MAEDA
Update locales (#16045).

History

#1 - 2014-02-06 18:46 - Gurvan Le Dromaguet
Works against 2.4-stable rev 12697

#2 - 2014-03-03 12:03 - Toshi MARUYAMA

- Description updated

#3 - 2014-03-03 12:05 - Toshi MARUYAMA

* You missed db migrate file.
* mix tabs and spaces
¢ please add tests

#4 - 2014-03-03 12:08 - Gurvan Le Dromaguet
- File 20131010000000_add_previous_assignee.rb added

Thanks for pointing out !!! attached file, | will work on adding a test.

#5 - 2014-03-03 12:20 - Gurvan Le Dromaguet
Toshi MARUYAMA wrote:
® mix tabs and spaces

What is the rule for Redmine ?
#6 - 2014-03-03 12:34 - Toshi MARUYAMA
Gurvan Le Dromaguet wrote:

Toshi MARUYAMA wrote:

e mix tabs and spaces

What is the rule for Redmine ?

two spaces for indent.

#7 - 2014-03-26 11:44 - Samuel Samfra

dear all, how do | install this ? patch -p0 for the patch ? What about the rb file ? thank you.. | come from the Java world :)
#8 - 2014-03-26 11:48 - Gurvan Le Dromaguet
Samuel Samfra wrote:
dear all, how do | install this ? patch -p0 for the patch ? What about the rb file ? thank you.. | come from the Java world :)
1- apply "patch -p0"

2- copy rb file to db/migrate
3- run "RAILS_ENV=production rake db:migrate"

#9 - 2016-11-16 13:29 - Go MAEDA

- Has duplicate Feature #24319: Last assigned to option in the Assignee selection list added

#10 - 2016-11-17 09:18 - Luka Liidicke

| have a solution for this which does not require an extra column in the database for this, the information can be gathered from the journal_details
| am mentioning it just in case the reason for ignoring this proposal is the extra column.

#11 - 2016-11-17 09:26 - Go MAEDA

Luka Ludicke wrote:

| have a solution for this which does not require an extra column in the database for this, the information can be gathered from the journal_details

Sounds great. Could you attach your patch to this issue?
#12 - 2016-11-17 11:43 - Luka Liidicke
Alright, this from how | patched it at our company.

As you can see from the comments, it is a work in progress.
If you like it and want to include it, | can make a "cleaner" diff and add a unit test for the last_assignee method.

(my colleagues really love the feature)

things to look out for:

the option should not come up if current user und last_assignee are the same
the option should not come up if last_assignee is nil

when there is old assignee (new issue), the last_assignee should be the author (TODO)
the option should not appear in issue category and bulk update

#13 - 2016-11-17 11:43 - Luka Liidicke
- File last_assignee_wip.diff added

#14 - 2017-07-25 12:38 - Luka Lidicke
Luka Ludicke wrote:

If you like it and want to include it, | can make a "cleaner" diff and add a unit test for the last_assignee method.

like | said, if you like it | would make the effort for a clean patch that you could "just" apply...

#15 - 2017-07-25 12:49 - Luka Lidicke

suggestions for specs

Test Plan
Edit Issue

1. open issue edit form

2. use select box

3. expect: last assignee is shown in the fist options
4. expect: assignment to that user is successful

bulk edit

1. open multiple issues with batch edit
2. expect: successful page load and no last assignee option in assigned_to select box

Issue Category

1. open project settings configuration

2. open issue categories tab

3. edit issue category

4. expect: successful page load and no last assignee option in assigned_to select box

New Issue

1. create new issue with an assignee

2. open edit page of that issue

3. expect: last assignee shows the author of the issue
4. expect: assignment to the user is successful

#16 - 2018-02-17 16:02 - Albrecht DreB

| applied the patch “last_assignee_wip.diff” to a standard Debian Stretch Redmine (v. 3.3.1), and it works somehow — only the value in the combo
reads

<< <span class="translation_missing"; title="translation missing: en.issue.last_assignee">Last Assignee</span>
>>

Anything | missed here?

BTW, it would be cool if the Last Assignee could be added to the Field Permissions in the workflow configuration, i.e. as an additional option for the
Assignee field, which would actually force setting the previous assignee whenever the ticket is edited. Think of a typical (for me) use case: developer
A needs feedback from reporter R, who has only the permission to set the Assignee field to the previous one. So A just sets the assignee to R. Now,

when R edits the ticket, it will automatically be assigned back to A, avoiding all problems of a ticket mistakenly being assigned to another person.
Would such an implementation be possible?

#17 - 2018-02-27 22:10 - Albrecht DreB

Albrecht Dref3 wrote:
| applied the patch “last_assignee_wip.diff” to a standard Debian Stretch Redmine (v. 3.3.1), and it works somehow — only the value in the
combo reads

It appears that changing in app/helpers/application_helper.rb the line

s << content_tag('option', "<< #{t('issue.last_assignee', name: User.find_by_id(last_assignee_id) .try (:na

me))} >>",
value: last_assignee_id) if (last_assignee_id && (last_assignee_id != User.current.id))
to
s << content_tag('option', "<< #{1l(:last_assignee, name: User.find_by_id(last_assignee_id) .try (:name))} >
>"
value: last_assignee_id) if (last_assignee_id && (last_assignee_id != User.current.id))
fixes this.
However, now the wrong “last assignee” is displayed...

After printing some debugging output, it seems that the journals in app/models/issue.rb, last_assigned_to are actually sorted as latest first. Replacing

journals.reverse_each do |[j|
by
journals.each do |7

seems to do the right thing. Can you confirm this is the proper solution?

#18 - 2018-07-25 06:59 - Mizuki ISHIKAWA
- File previous-assignee-v2.0.patch added

- File previous-assignee-v2.1.patch added

Thank you for sharing your patch, Luka Ludicke.
| think this feature will be useful in projects with many users.

| made some changes, such as adding a test to your patch.( and | removed it because some changes for German were included. )
— previous-assignee-v2.0.patch

Since | think that p"revious_assignee" is more appropriate than "last_assignee”, | also created a version patch that replaced the "previous".
— previous-assignee-v2.1.patch

Albrecht Dref3 wrote:
However, now the wrong “last assignee” is displayed...
After printing some debugging output, it seems that the journals in app/models/issue.rb, last_assigned_to are actually sorted as latest first.

Replacing [...] by [...] seems to do the right thing. Can you confirm this is the proper solution?

In my environment | seemed to work normally even with reverse_each.
Therefore, | use reverse_each also in the patch attached by me.

#19 - 2018-08-03 14:49 - Albrecht DreB
Mizuki ISHIKAWA wrote:
Albrecht Dref3 wrote:
However, now the wrong “last assignee” is displayed...
After printing some debugging output, it seems that the journals in app/models/issue.rb, last_assigned_to are actually sorted as latest first.
Replacing [...] by [...] seems to do the right thing. Can you confirm this is the proper solution?

In my environment | seemed to work normally even with reverse_each. Therefore, | use reverse_each also in the patch attached by me.

Hmmm, strange. Which Redmine version do you use?

#20 - 2018-08-06 09:35 - Mizuki ISHIKAWA
Albrecht Dref3 wrote:

Hmmm, strange. Which Redmine version do you use?

| tested on trunk( r17463 ) and 3.4 versions.

When | checked sql on rails console, it looks like ascending order.

[1] pry(main)> puts Journal.all.to_sqgl
SELECT "journals".* FROM "journals"

=> nil

[2] pry(main)> issue = Issue.first
[3] pry(main)> puts issue.journals.to_sqgl

SELECT "journals".* FROM "journals" WHERE "journals"."journalized_id" = 1 AND "journals"."journalized_type"
= 'Issue'

=> nil

thanks

#21 - 2018-08-16 18:15 - Go MAEDA

- Related to Feature #19501: Assign issue to <<author>> added

#22 - 2018-09-23 02:46 - Go MAEDA

- Target version set to Candidate for next major release

#23 - 2018-10-06 07:01 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

The patch looks good to me. Setting target version to 4.1.0.

#24 - 2019-02-03 09:38 - Go MAEDA

previous_assigned_to method in the patch should return nil if no previous assignee is found, but it returns
Journal::ActiveRecord_Associations_CollectionProxy which is the return value of journals.reverse_each.

Probably we should add nil at the end of the method.
# Returns the previous assignee from the issue history
def previous_assigned_to
journals.reverse_each do |j|
previous_assignee_change = j.detail_for_attribute 'assigned_to_id'
return User.find_by(id: previous_assignee_change.old_value.to_i) if previous_assignee_change &&
previous_assignee_change.old_value
end
nil
end

#25 - 2019-04-30 11:56 - Go MAEDA
- Related to Feature #14602: Assignee list should be (optionally) ordered by probability added

#26 - 2019-06-02 06:07 - Go MAEDA
- Related to Feature #23072: Speed-Up the setting of "assigned to" by showing good guesses at the top of the list added

#27 - 2019-09-05 18:02 - Go MAEDA

- Target version changed from 4.1.0 to Candidate for next major release

#28 - 2023-04-06 10:09 - Mizuki ISHIKAWA

- File previous-assignee-v3.patch added

Fixed conflicts with the latest code and added tests.

#29 - 2024-09-02 17:20 - Go MAEDA

- File previous-assignee-v4.patch added

| have updated the patch as follows:

1. Changed the method name from Issue#previous_assigned_to to Issue#prior_assigned_to

This change was made to avoid confusion with the existing Issue#previous_assignee method, which serves a different purpose.
2. Optimized Issue#prior_assigned_to

The method was optimized to retrieve the previous assignee id using a single query.

Before optimization:
redmine-app (dev) > Issue.find(30) .previous_assigned_to

Issue Load (0.1lms) SELECT "issues".* FROM "issues" WHERE "issues"."id" = ? LIMIT °? [r"id", 301, ["LIMIT",
111

Journal Load (0.lms) SELECT "journals".* FROM "Jjournals" WHERE "journals"."journalized_id" = ? AND "journal
s"."journalized_type" = ? [["journalized_id", 30], ["journalized_type", "Issue"]]

JournalDetail Load (0.1lms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
J J J
al_id" = ? [["Journal_id", 55]]
JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
J J J
al_id" = ? [["Jjournal_id", 541]
JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
al_id" = ? [["Jjournal_id", 531]
JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
J J J
al_id" = ? [["journal_id", 52]]
JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
J J J

al_id" = ? [["journal_id", 511]
JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
al_id" = ? [["journal_id", 50]]

JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
al_id" = 2 [["journal_id", 491]]
JournalDetail Load (0.1ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ

al_id" = 2 [["journal_id", 48]]

JournalDetail Load (0.0ms) SELECT "journal_details".* FROM "journal_details" WHERE "journal_details"."journ
al_id" = ? [["Journal_id", 47]]

User Load (0.3ms) SELECT "users".* FROM "users" WHERE "users"."type" = ? AND "users"."id" = ? LIMIT ? [["t
ype", "User"], ["id", 1], ["LIMIT", 1]]

After optimization:

redmine-app (dev)> Issue.find(30) .prior_assigned_to

Issue Load (0.3ms) SELECT "issues".* FROM "issues" WHERE "issues"."id" = ? LIMIT ? [["id", 30], ["LIMIT",
111

Journal Pluck (0.2ms) SELECT "old_value" FROM "journals" INNER JOIN "journal_details" "details" ON "details
"."journal_id" = "journals"."id" WHERE "journals"."journalized_id" = ? AND "journals"."journalized_type" = ? A
ND "details"."prop_key" = ? AND "details"."old_value" IS NOT NULL ORDER BY "journals"."id" DESC LIMIT ? [["jo
urnalized_id", 30], ["journalized_type", "Issue"], ["prop_key", "assigned_to_id"], ["LIMIT", 11]

Principal Load (0.1lms) SELECT "users".* FROM "users" WHERE "users"."id" = ? LIMIT 2 [["id", 1], ["LIMIT",
111

#30 - 2024-09-03 11:27 - Go MAEDA

- File clipboard-202409031826-4kecg.png added
- File previous-assignee-v5.patch added

| have updated the patch again.

In the new patch, | have added an optgroup labeled "Author / Prior assignee”, allowing users to select not only the previous assignee but also the
issue’s author. The author is displayed first, followed by the prior assignee.

This enhancement addresses a feature request posted as #19501, the feature to quickly select the issue's author.
#31 - 2024-09-03 11:39 - Go MAEDA

- Related to Feature #35282: Assign to former/previous assignee short cut added

#32 - 2024-09-04 02:45 - Go MAEDA
- File previous-assignee-v6.patch added

- File clipboard-202409040942-dihus.png added

| have slightly updated the patch. The revised patch always shows the author and prior assignee even if they are unassignable.
The previous patch did not show the author or prior assignee when they were unassignable, for example, they were locked or removed from the

projects' members after their activity. However, | found the behavior confusing and may be mistaken for a defect of Redmine. So, | have improved the
patch to display an unassignable author or prior assignee in disabled state.
#33 - 2024-09-04 03:29 - Go MAEDA

- File previous-assignee-v6.patch added

#34 - 2024-09-04 03:29 - Go MAEDA

- File deleted (previous-assignee-v6.patch)

#35 - 2024-09-09 15:52 - Go MAEDA

- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.

#36 - 2024-09-10 08:24 - Marius BALTEANU

This is nice, but | think on new issue form, we should not show the new group because in most of the cases you're going to see your user three times:

® <<me>>
e in "Author / Prior assignee" group because you're the author of the new issue
¢ in the "User" group

Also, two additional thoughts on this:

o if we really want to add a new group, maybe it is better to name it "Involved" which is a term already used in the notification setting and it means
that the user is author, assignee or prior assignee. Also, this allows us on future development to add new users that are already involved in the
issue somehow.

¢ if we don't want to a new group, maybe it is good enough to add the author and the prior assignee right after <<me>> (which is first entry) and
add the label next to the name, something like Redmine Admin (Author), John Doe (Previous assignee).

What do you think?

#37 - 2024-09-10 12:21 - Go MAEDA

- File clipboard-202409101910-mqgn4m.png added

- File clipboard-202409101913-akkjl.png added

- File previous-assignee-v7.patch added

Marius, thank you for reviewing the patch.

Marius BALTEANU wrote in #note-36:
This is nice, but | think on new issue form, we should not show the new group because in most of the cases you're going to see your user three
times:

| have updated the patch not to display the new group on the "New issue" form.
Also, two additional thoughts on this:

e if we really want to add a new group, maybe it is better to name it "Involved" which is a term already used in the notification setting and it
means that the user is author, assignee or prior assignee. Also, this allows us on future development to add new users that are already
involved in the issue somehow.

e if we don't want to a new group, maybe it is good enough to add the author and the prior assignee right after <<me>> (which is first entry)
and add the label next to the name, something like Redmine Admin (Author), John Doe (Previous assignee).

| have changed the group name to "Involved users".

| would still like to add the new group because the dropdown looks messy to me without it, and the name like "John Smith (Previous assignee)" is too
long. Please see the following screenshots.
#38 - 2024-09-14 09:42 - Go MAEDA

- File previous-assignee-v8.patch added

| have updated the patch.

In #note-37, | renamed the group to "Involved users" following the suggestion in #note-36. However, | later felt that this name was somewhat
ambiguous, so | changed it to "Author / Previous assignee" in the committed code. That said, in the i18n translation files, the label remains as
label_involved_principals, and the variable names in the code also still use the word "involved". This should allow for future extension to display other

types of users, in which case we could simply update the translation to “Involved” or another appropriate term.

From config/locales/en.yml:

label_involved_principals: Author / Previous assignee

#39 - 2024-09-15 08:32 - Go MAEDA

- Subject changed from Add "Previous Assignee" entry when changing issue assignee to Add "Author / Previous assignee" group to assignee

dropdown in issue form
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch in r23059.

The assignee dropdown now has a new options group "Author / Previous assignee" and you can choose the author and the previous assignee from

there.

#40 - 2024-09-17 03:57 - Go MAEDA

- Tracker changed from Patch to Feature

#41 - 2024-10-16 07:50 - Pete Davis

This is exciting to see being developed. | have a simple question (I think) but appreciate it may totally not fit with this work.

The idea is that on any issue, alongside the EDIT | WATCH | COPY options (on the top+bottom right of the screen), we add another which is REPLY
which then triggers much of what you are working towards, namely to ensure the assignee is changed back to the person who just submitted the

ticket or the comment.

Does this idea have any validity to others? It seems to simply the steps - namely instead of clicking EDIT and having to do anything to set the

assignee to the prior assignee, you just click on REPLY.

| dare say there could be a bunch of workflows | am not considering - but for over 90% of your usage, we are commenting and resetting assignee to

the person who previously was the assignee.

Just a thought. Appreciate your efforts.

#42 - 2025-04-23 07:09 - Mikhail Nikitin
- File clipboard-202504231004-pc651.png added

Go MAEDA wrote in #note-39:

Committed the patch in r23059.

The assignee dropdown now has a new options group "Author / Previous assignee" and you can choose the author and the previous assignee

from there.

Greetings! Thank you for that great feature.

Is there a way to make a button like "Assign to me" but that will assign the issue back to the last assignee? Will be easier and less clicks. Users will
not have to read or click through the list. They can even not pay attention who was the last assignee, just give it back to whoever was assigned before
the current assignee. Even if it was not assigned to you. Clicking this button again and again will cycle through the last two assignees until someone

different is assigned manually.
clipboard-202504231004-pc651.png

Files

previous-assignee-v1.0.patch 4.92 KB 2014-02-06 Gurvan Le Dromaguet
20131010000000_add_previous_assignee.rb 213 Bytes 2014-03-03 Gurvan Le Dromaguet
last_assignee_wip.diff 3 KB 2016-11-17 Luka Ludicke
previous-assignee-v2.0.patch 4.34 KB 2018-07-25 Mizuki ISHIKAWA
previous-assignee-v2.1.patch 4.46 KB 2018-07-25 Mizuki ISHIKAWA
previous-assignee-v3.patch 4.66 KB 2023-04-06 Mizuki ISHIKAWA
previous-assignee-v4.patch 4.75 KB 2024-09-02 Go MAEDA
clipboard-202409031826-4kecg.png 144 KB 2024-09-03 Go MAEDA
previous-assignee-v5.patch 6.58 KB 2024-09-03 Go MAEDA
